#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <dos.h>
#include <errno.h>

#define _A_ALL  (_A_RDONLY|_A_HIDDEN|_A_SYSTEM|_A_VOLID|_A_SUBDIR|_A_ARCH)
#define _A_NONE 0
#define TRUE    1
#define FALSE   0


char *attrib_str (unsigned attrib);
char *date_str (unsigned date);


void main (unsigned argc, char *argv[])
 {
  char          fname[_MAX_PATH+1];
  int           find_attrib     = _A_ALL;
  int           using_attrib    = FALSE;

  int           or_attrib       = _A_NONE;
  int           and_attrib      = _A_ALL;
  int           changing_attrib = FALSE;

  struct find_t fileinfo;
  unsigned      errorcode;
  int           attrib;

  unsigned      i;
  static char   path_buf[_MAX_PATH+1],
		drive_buf[3],
		dir_buf[_MAX_PATH+1],
		fname_buf[9],
		ext_buf[5];

  time_t        lTime;
  struct tm     tmTime;
  static char   sTime[17];


  fname[0]='\0';
  for (i=1; i<argc; i++)
   {
    if (argv[i][0] != '/')                      // "FILENAME"
     {
      if (fname[0] != '\0')
       {
	printf ("\nCan not process multiple file names: %s\n", argv[i]);
	exit (-1);
       }
      if (!_fullpath (fname, argv[i], _MAX_PATH))
       {
	printf ("\nError in specified file name: %s\n", argv[i]);
	exit (-1);
       }
      if (!strchr (fname, '.'))
       {
	strcat (fname, ".*");
       }
      continue;
     }

    if (strcmpi (argv[i], "/A+") == 0 ||        // "/A+-"
	strcmpi (argv[i], "/A-") == 0)
     {
      changing_attrib = TRUE;
      if (argv[i][2]=='+')
       {
	or_attrib |= _A_ARCH;
	and_attrib |= _A_ARCH;
       }
      else
       {
	or_attrib &= ~_A_ARCH;
	and_attrib &= ~_A_ARCH;
       }
      continue;
     }

    if (strcmpi (argv[i], "/R+") == 0 ||        // "/R+-"
	strcmpi (argv[i], "/R-") == 0)
     {
      changing_attrib = TRUE;
      if (argv[i][2]=='+')
       {
	or_attrib |= _A_RDONLY;
	and_attrib |= _A_RDONLY;
       }
      else
       {
	or_attrib &= ~_A_RDONLY;
	and_attrib &= ~_A_RDONLY;
       }
      continue;
     }

    if (strcmpi (argv[i], "/H+") == 0 ||        // "/H+-"
	strcmpi (argv[i], "/H-") == 0)
     {
      changing_attrib = TRUE;
      if (argv[i][2]=='+')
       {
	or_attrib |= _A_HIDDEN;
	and_attrib |= _A_HIDDEN;
       }
      else
       {
	or_attrib &= ~_A_HIDDEN;
	and_attrib &= ~_A_HIDDEN;
       }
      continue;
     }

    if (strcmpi (argv[i], "/S+") == 0 ||        // "/S+-"
	strcmpi (argv[i], "/S-") == 0)
     {
      changing_attrib = TRUE;
      if (argv[i][2]=='+')
       {
	or_attrib |= _A_SYSTEM;
	and_attrib |= _A_SYSTEM;
       }
      else
       {
	or_attrib &= ~_A_SYSTEM;
	and_attrib &= ~_A_SYSTEM;
       }
      continue;
     }

    if (strcmpi (argv[i], "/A") == 0)           // "/A"
     {
      if (!using_attrib)
       {
	using_attrib = TRUE;
	find_attrib = _A_ARCH;
       }
      else
       {
	find_attrib |= _A_ARCH;
       }
      continue;
     }

    if (strcmpi (argv[i], "/R") == 0)           // "/R"
     {
      if (!using_attrib)
       {
	using_attrib = TRUE;
	find_attrib = _A_RDONLY;
       }
      else
       {
	find_attrib |= _A_RDONLY;
       }
      continue;
     }

    if (strcmpi (argv[i], "/H") == 0)           // "/H"
     {
      if (!using_attrib)
       {
	using_attrib = TRUE;
	find_attrib = _A_HIDDEN;
       }
      else
       {
	find_attrib |= _A_HIDDEN;
       }
      continue;
     }

    if (strcmpi (argv[i], "/S") == 0)           // "/S"
     {
      if (!using_attrib)
       {
	using_attrib = TRUE;
	find_attrib = _A_SYSTEM;
       }
      else
       {
	find_attrib |= _A_SYSTEM;
       }
      continue;
     }

    if (strcmpi (argv[i], "/D") == 0)           // "/D"
     {
      if (!using_attrib)
       {
	using_attrib = TRUE;
	find_attrib = _A_SUBDIR;
       }
      else
       {
	find_attrib |= _A_SUBDIR;
       }
      continue;
     }

    printf ("\nUnrecognized argument: %s\n", argv[i]);
    exit (-1);
   }


  if (fname[0] == '\0')
   {
    strcpy (fname, "*.*");
   }

  i=0;
  errorcode = _dos_findfirst (fname, _A_ALL, &fileinfo);
  while (!errorcode)
   {
    /*
      if (fileinfo.attrib & (_A_SUBDIR|_A_VOLID))       // Skip if DIR or VOL
       {
	errorcode = _dos_findnext (&fileinfo);
	continue;
       }
    */

    if (using_attrib)                                   // Skip if filtered
     {
      if ((find_attrib & fileinfo.attrib) != find_attrib)
       {
	errorcode = _dos_findnext (&fileinfo);
	continue;
       }
     }

    attrib = fileinfo.attrib;
    if (changing_attrib)
     {
      attrib |= or_attrib;
      attrib &= and_attrib;
      if (attrib != fileinfo.attrib)
       {
	_dos_setfileattr (fileinfo.name, attrib);
       }
     }

    if (fileinfo.name[0]=='.')                          // Print name (13)
     {
      printf ("%-12s ", fileinfo.name);
     }
    else
     {
      if (!_fullpath (path_buf, fileinfo.name, _MAX_PATH))
       {
	printf("\nError calling _fullpath with filename: %s\n",
	  fileinfo.name);
	exit(-1);
       }
      _splitpath (path_buf, drive_buf, dir_buf, fname_buf, ext_buf);

      printf ("%-8s", fname_buf);
      printf ("%-4s ", ext_buf);
     }

    printf ("%4s ", attrib_str (attrib));               // Print attrib (5)

    if (attrib & _A_SUBDIR)                             // Print size (10)
     {
      printf ("<DIR>     ");
     }
    else if (attrib & _A_VOLID)
     {
      printf ("Volume ID ");
     }
    else
     {
      printf ("%9lu ", fileinfo.size);
     }

    printf ("            ");                            // Print spaces (12)

    errorcode = _dos_findnext (&fileinfo);
   }
 }


char *attrib_str (unsigned attrib)
 {
  static char *str = "    ";
  unsigned i;

  for (i=0; i<4; i++)
   {
    str[i] = ' ';
   }

  if (attrib & _A_RDONLY)
    str[0]='R';
  if (attrib & _A_HIDDEN)
    str[1]='H';
  if (attrib & _A_SYSTEM)
    str[2]='S';
	/*
	  if (attrib & _A_VOLID )
	    str[3]='V';
	  if (attrib & _A_SUBDIR)
	    str[4]='D';
	*/
  if (attrib & _A_ARCH  )
    str[3]='A';
  return str;
 }

/*
char *date_str (unsigned date)
 {
  char          *str = "00-00-00";
  unsigned      mo, dy, yr, days;

  days = 0;
  mo = 1;
  dy = 1;
  yr = 80;

  while (1)
   {
    if (yr%4)
					// Not a leapyear
     {
      if (days+365 > date)
       {
	break;
       }
      yr++;
      days+=365;
     }
    else
					// A leapyear
     {
      if (days+364 > date)
       {
	break;
       }
      yr++;
      days+=364;
     }
   }

  while (1)
   {
    if (mo==1 || mo==3 || mo==5 || mo==7 || mo==8 || mo==10 || mo==12)
					// 31 day month
     {
      if (days+31 > date)
       {
	break;
       }
      mo++;
      days+=31;
     }
    else if (mo!=2)
					// 30 day month
     {
      if (days+30 > date)
       {
	break;
       }
      mo++;
      days+=30;
     }
    else if (yr%4)
					// 29 day month
     {
      if (days+29 > date)
       {
	break;
       }
      mo++;
      days+=29;
     }
    else
     {
      if (days+28 > date)
       {
	break;
       }
      mo++;
      days+=28;
     }
    if (mo==13)
     {
      printf ("\nYear did not catch days in date_str!\n");
      exit (-1);
     }
   }

  dy += date - days;
  sprintf (str, "%2d-%2d-%2d", mo, dy, yr);
  return str;
 }

*/
